commit 8d1195dc3ce331fd823c569ff001537631343f26
Author: Andreas Kohlbecker <a.kohlbecker@bgbm.org>
Date:   Thu Mar 2 07:57:18 2017 +0100

    removing old unused deigns

diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/design/phycobank/PhycobankApplicationDesign.java b/src/main/java/eu/etaxonomy/cdm/vaadin/design/phycobank/PhycobankApplicationDesign.java
deleted file mode 100644
index dc0dd290..00000000
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/design/phycobank/PhycobankApplicationDesign.java
+++ /dev/null
@@ -1,35 +0,0 @@
-package eu.etaxonomy.cdm.vaadin.design.phycobank;
-
-import com.vaadin.annotations.AutoGenerated;
-import com.vaadin.annotations.DesignRoot;
-import com.vaadin.ui.Button;
-import com.vaadin.ui.CssLayout;
-import com.vaadin.ui.HorizontalLayout;
-import com.vaadin.ui.declarative.Design;
-
-/** 
- * !! DO NOT EDIT THIS FILE !!
- * 
- * This class is generated by Vaadin Designer and will be overwritten.
- * 
- * Please make a subclass with logic and additional interfaces as needed,
- * e.g class LoginView extends LoginDesign implements View { }
- */
-@DesignRoot
-@AutoGenerated
-@SuppressWarnings("serial")
-public class PhycobankApplicationDesign extends HorizontalLayout {
-    protected CssLayout menu;
-    protected Button dashboard;
-    protected Button reports;
-    protected Button customize;
-    protected Button help;
-    protected Button login;
-    protected Button userAccount;
-    protected Button messagesButton;
-    protected CssLayout content;
-
-    public PhycobankApplicationDesign() {
-        Design.read(this);
-    }
-}
diff --git a/src/main/resources/eu/etaxonomy/cdm/vaadin/design/phycobank/PhycobankApplicationDesign.html b/src/main/resources/eu/etaxonomy/cdm/vaadin/design/phycobank/PhycobankApplicationDesign.html
deleted file mode 100644
index bf12f447..00000000
--- a/src/main/resources/eu/etaxonomy/cdm/vaadin/design/phycobank/PhycobankApplicationDesign.html
+++ /dev/null
@@ -1,53 +0,0 @@
-<!doctype html>
-<html>
- <head>
-  <meta charset="UTF-8">
-  <meta name="design-properties" content="{&quot;RULERS_VISIBLE&quot;:true,&quot;GUIDELINES_VISIBLE&quot;:false,&quot;SNAP_TO_OBJECTS&quot;:true,&quot;SNAP_TO_GRID&quot;:true,&quot;SNAPPING_DISTANCE&quot;:10,&quot;JAVA_SOURCES_ROOT&quot;:&quot;src/main/java&quot;,&quot;THEME&quot;:&quot;edit-valo&quot;}">
-  <meta name="vaadin-version" content="7.7.0">
- </head>
- <body>
-  <vaadin-horizontal-layout style-name="app-shell v-menu-responsive" responsive size-full>
-   <vaadin-css-layout style-name="navigation-bar-container" width="200px" height-full>
-    <vaadin-css-layout style-name="navigation-bar" size-full>
-     <vaadin-label primary-style-name="v-label logo" style-name="logo" plain-text>
-       PhycoBank 
-     </vaadin-label>
-     <vaadin-css-layout style-name="navigation" width-full _id="menu">
-      <vaadin-button icon="fonticon://FontAwesome/f044" style-name="borderless huge" width-full plain-text _id="dashboard">
-        New 
-      </vaadin-button>
-      <vaadin-button icon="fonticon://FontAwesome/f061" style-name="borderless huge" width-full plain-text _id="reports">
-        Continue 
-      </vaadin-button>
-      <vaadin-button icon="fonticon://FontAwesome/f03a" style-name="borderless huge" width-full plain-text _id="customize">
-        List 
-      </vaadin-button>
-     </vaadin-css-layout>
-    </vaadin-css-layout>
-   </vaadin-css-layout>
-   <vaadin-vertical-layout style-name="content-container" size-full :expand>
-    <vaadin-horizontal-layout style-name="banner" width-full :bottom :right>
-     <vaadin-css-layout :bottom :right>
-      <vaadin-button style-name="borderless small" plain-text _id="help">
-        Help 
-      </vaadin-button>
-      <vaadin-button style-name="borderless small" plain-text _id="login">
-        Login 
-      </vaadin-button>
-      <vaadin-button icon="fonticon://FontAwesome/f007" style-name="borderless small" plain-text _id="userAccount">
-        User Name 
-      </vaadin-button>
-      <vaadin-button icon="fonticon://FontAwesome/f0e0" style-name="borderless small" _id="messagesButton">
-       <span class="valo-menu-badge">123</span>
-      </vaadin-button>
-     </vaadin-css-layout>
-    </vaadin-horizontal-layout>
-    <vaadin-css-layout size-full _id="content" :expand>
-     <vaadin-css-layout size-full>
-      <vaadin-css-layout style-name="content-section padding" size-full></vaadin-css-layout>
-     </vaadin-css-layout>
-    </vaadin-css-layout>
-   </vaadin-vertical-layout>
-  </vaadin-horizontal-layout>
- </body>
-</html>
\ No newline at end of file