commit a1287e8685f698f8762bc30cedec6eeb3ec3eeca
Author: jenkins <jenkins-int@bgbm.org>
Date:   Wed Jul 6 15:53:55 2016 +0200

    updating poms for branch'release/4.2.0' with non-snapshot versions

diff --git a/cdmlib-commons/pom.xml b/cdmlib-commons/pom.xml
index e0a6158865..484ffd84be 100644
--- a/cdmlib-commons/pom.xml
+++ b/cdmlib-commons/pom.xml
@@ -6,7 +6,7 @@
   <parent>
     <groupId>eu.etaxonomy</groupId>
     <artifactId>cdmlib-parent</artifactId>
-    <version>4.2.0-SNAPSHOT</version>
+    <version>4.2.0</version>
 	<relativePath>../pom.xml</relativePath>
   </parent>
   
diff --git a/cdmlib-db/pom.xml b/cdmlib-db/pom.xml
index 28f9f97867..dc9f53e314 100644
--- a/cdmlib-db/pom.xml
+++ b/cdmlib-db/pom.xml
@@ -3,7 +3,7 @@
   <parent>
     <groupId>eu.etaxonomy</groupId>
     <artifactId>cdmlib-parent</artifactId>
-		<version>4.2.0-SNAPSHOT</version>
+		<version>4.2.0</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
 
diff --git a/cdmlib-ext/pom.xml b/cdmlib-ext/pom.xml
index 2521e5fe6d..090ad5c99d 100644
--- a/cdmlib-ext/pom.xml
+++ b/cdmlib-ext/pom.xml
@@ -6,7 +6,7 @@
 	<parent>
 		<groupId>eu.etaxonomy</groupId>
 		<artifactId>cdmlib-parent</artifactId>
-	    <version>4.2.0-SNAPSHOT</version>
+	    <version>4.2.0</version>
 		<relativePath>../pom.xml</relativePath>
 	</parent>
 
diff --git a/cdmlib-io/pom.xml b/cdmlib-io/pom.xml
index 2159ff8d0c..4bd6c420f5 100644
--- a/cdmlib-io/pom.xml
+++ b/cdmlib-io/pom.xml
@@ -4,7 +4,7 @@
   <parent>
     <groupId>eu.etaxonomy</groupId>
     <artifactId>cdmlib-parent</artifactId>
-		<version>4.2.0-SNAPSHOT</version>
+		<version>4.2.0</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
 
diff --git a/cdmlib-model/pom.xml b/cdmlib-model/pom.xml
index 6410f9cfc0..fedd031857 100644
--- a/cdmlib-model/pom.xml
+++ b/cdmlib-model/pom.xml
@@ -2,7 +2,7 @@
   <parent>
     <artifactId>cdmlib-parent</artifactId>
     <groupId>eu.etaxonomy</groupId>
-    <version>4.2.0-SNAPSHOT</version>
+    <version>4.2.0</version>
   <relativePath>../pom.xml</relativePath>
   </parent>
   <modelVersion>4.0.0</modelVersion>
diff --git a/cdmlib-persistence/pom.xml b/cdmlib-persistence/pom.xml
index 1839618664..bf453b28ba 100644
--- a/cdmlib-persistence/pom.xml
+++ b/cdmlib-persistence/pom.xml
@@ -3,7 +3,7 @@
   <parent>
     <groupId>eu.etaxonomy</groupId>
     <artifactId>cdmlib-parent</artifactId>
-		<version>4.2.0-SNAPSHOT</version>
+		<version>4.2.0</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
 
diff --git a/cdmlib-print/pom.xml b/cdmlib-print/pom.xml
index e573eef979..f422248d8f 100644
--- a/cdmlib-print/pom.xml
+++ b/cdmlib-print/pom.xml
@@ -3,7 +3,7 @@
   <parent>
     <artifactId>cdmlib-parent</artifactId>
     <groupId>eu.etaxonomy</groupId>
-    <version>4.2.0-SNAPSHOT</version>
+    <version>4.2.0</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
   <modelVersion>4.0.0</modelVersion>
diff --git a/cdmlib-remote-webapp/pom.xml b/cdmlib-remote-webapp/pom.xml
index e9f89bc351..97d53c6706 100755
--- a/cdmlib-remote-webapp/pom.xml
+++ b/cdmlib-remote-webapp/pom.xml
@@ -4,7 +4,7 @@
   <parent>
     <artifactId>cdmlib-parent</artifactId>
     <groupId>eu.etaxonomy</groupId>
-    <version>4.2.0-SNAPSHOT</version>
+    <version>4.2.0</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
 
diff --git a/cdmlib-remote/pom.xml b/cdmlib-remote/pom.xml
index 2e6f522018..7547433c28 100644
--- a/cdmlib-remote/pom.xml
+++ b/cdmlib-remote/pom.xml
@@ -4,7 +4,7 @@
   <parent>
     <groupId>eu.etaxonomy</groupId>
     <artifactId>cdmlib-parent</artifactId>
-    <version>4.2.0-SNAPSHOT</version>
+    <version>4.2.0</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
 
diff --git a/cdmlib-services/pom.xml b/cdmlib-services/pom.xml
index 778050412a..eafb803f55 100644
--- a/cdmlib-services/pom.xml
+++ b/cdmlib-services/pom.xml
@@ -6,7 +6,7 @@
   <parent>
     <groupId>eu.etaxonomy</groupId>
     <artifactId>cdmlib-parent</artifactId>
-    <version>4.2.0-SNAPSHOT</version>
+    <version>4.2.0</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
 
diff --git a/cdmlib-test/pom.xml b/cdmlib-test/pom.xml
index 06742b0fbc..dd5528e169 100644
--- a/cdmlib-test/pom.xml
+++ b/cdmlib-test/pom.xml
@@ -3,7 +3,7 @@
   <parent>
     <groupId>eu.etaxonomy</groupId>
     <artifactId>cdmlib-parent</artifactId>
-		<version>4.2.0-SNAPSHOT</version>
+		<version>4.2.0</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
 
diff --git a/pom.xml b/pom.xml
index 92d1eaeb60..f8b7c991e8 100644
--- a/pom.xml
+++ b/pom.xml
@@ -3,7 +3,7 @@
   <modelVersion>4.0.0</modelVersion>
   <groupId>eu.etaxonomy</groupId>
   <artifactId>cdmlib-parent</artifactId>
-  <version>4.2.0-SNAPSHOT</version>
+  <version>4.2.0</version>
   <name>CDM Library</name>
   <description>The Java implementation of the Common Data Model (CDM), the data model for EDIT's internet platform for cybertaxonomy.</description>
   <url>http://cybertaxonomy.eu/cdmlib/</url>