commit c7cc7a1848ff05b381b13f6e06c40d3ef52e4f4d
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Tue Apr 25 13:32:18 2017 +0200

    fix #6587 Correctly order "Window" menu

diff --git a/eu.etaxonomy.taxeditor.bulkeditor/fragment.e4xmi b/eu.etaxonomy.taxeditor.bulkeditor/fragment.e4xmi
index 96124e17b..9864da75e 100644
--- a/eu.etaxonomy.taxeditor.bulkeditor/fragment.e4xmi
+++ b/eu.etaxonomy.taxeditor.bulkeditor/fragment.e4xmi
@@ -15,4 +15,9 @@
       <parameters xmi:id="_pNpDASQ6EeeKsvEah5BAoQ" elementId="eu.etaxonomy.taxeditor.bulkeditor.menu.admin.groupBulk.groupParam" name="taxeditor-bulkeditor.commandParameter.inputType" value="bulkeditor.input.group"/>
     </elements>
   </fragments>
+  <fragments xsi:type="fragment:StringModelFragment" xmi:id="_gHUPICkFEeeCvszP-_feIA" featurename="children" parentElementId="eu.etaxonomy.taxeditor.workbench.menu.window" positionInList="first">
+    <elements xsi:type="menu:Menu" xmi:id="_jpxCMCkFEeeCvszP-_feIA" elementId="bulkeditor.menus.openmenu" label="%menu.label" mnemonics="">
+      <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_nae6wCkFEeeCvszP-_feIA" coreExpressionId="isCdmStoreConnected"/>
+    </elements>
+  </fragments>
 </fragment:ModelFragments>
diff --git a/eu.etaxonomy.taxeditor.bulkeditor/plugin.xml b/eu.etaxonomy.taxeditor.bulkeditor/plugin.xml
index b91136fba..b80d6e61e 100644
--- a/eu.etaxonomy.taxeditor.bulkeditor/plugin.xml
+++ b/eu.etaxonomy.taxeditor.bulkeditor/plugin.xml
@@ -35,17 +35,7 @@
    <extension
          point="org.eclipse.ui.menus">
       <menuContribution
-            locationURI="menu:eu.etaxonomy.taxeditor.workbench.menu.window?before=eu.etaxonomy.taxeditor.application.windowMenu.last">
-         <menu
-               id="bulkeditor.menus.openmenu"
-               label="%menu.label">
-            <visibleWhen
-                  checkEnabled="true">
-               <reference
-                     definitionId="isCdmStoreConnected">
-               </reference>
-            </visibleWhen>
-         </menu>
+            locationURI="menu:eu.etaxonomy.taxeditor.workbench.menu.window">
          <menu
                label="%menu.label.0">
             <visibleWhen
diff --git a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle.properties b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle.properties
index 89b5bdbf3..677981fcc 100644
--- a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle.properties
+++ b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle.properties
@@ -41,7 +41,6 @@ view.name.6 = Derivative Search
 view.name.7 = Specimen Search
 
 editor.name = Defined Term Editor
-menu.label = Show View
 command.label = Derivative Search
 command.label.0 = Details
 command.label.1 = Supplemental
diff --git a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle_de.properties b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle_de.properties
index c87c0875b..5240f72b3 100644
--- a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle_de.properties
+++ b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/bundle_de.properties
@@ -41,7 +41,6 @@ view.name.6 = Derivatsuche
 view.name.7 = Specimensuche
 view.name.8 = GBif Specimen Import
 editor.name = Editor f\u00fcr definierte Begriffe 
-menu.label = Zeige Ansicht
 command.label = Derivatsuche
 command.label.0 = Details
 command.label.1 = Zusatzdaten
diff --git a/eu.etaxonomy.taxeditor.store/fragment.e4xmi b/eu.etaxonomy.taxeditor.store/fragment.e4xmi
index a2e5a1098..e55d3cb1d 100644
--- a/eu.etaxonomy.taxeditor.store/fragment.e4xmi
+++ b/eu.etaxonomy.taxeditor.store/fragment.e4xmi
@@ -4,31 +4,29 @@
   <fragments xsi:type="fragment:StringModelFragment" xmi:id="_xVa1wCXXEeex9MwMOgUeWw" featurename="descriptors" parentElementId="org.eclipse.e4.legacy.ide.application">
     <elements xsi:type="basic:PartDescriptor" xmi:id="_2xmxoCXXEeex9MwMOgUeWw" elementId="eu.etaxonomy.taxeditor.store.partdescriptor.sessionsView" label="%view.name.SESSIONS" closeable="true" contributionURI="bundleclass://eu.etaxonomy.taxeditor.store/eu.etaxonomy.taxeditor.view.sessions.SessionsViewPart"/>
   </fragments>
-  <fragments xsi:type="fragment:StringModelFragment" xmi:id="_3rW8wCXaEeex9MwMOgUeWw" featurename="children" parentElementId="eu.etaxonomy.taxeditor.workbench.menu.window">
-    <elements xsi:type="menu:Menu" xmi:id="_RaxPUCXdEeex9MwMOgUeWw" elementId="eu.etaxonomy.taxeditor.menu.showViewXX" label="%menu.label">
-      <children xsi:type="menu:HandledMenuItem" xmi:id="_K6sowCaGEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.details" label="%command.label.0" command="_bnVKsCZxEeeQLpuomSmVoQ">
-        <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_Qi6uICaJEeeTEd_pKXBflg" coreExpressionId="isCdmStoreConnected"/>
-        <parameters xmi:id="_h2OecCaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.view.detail"/>
-      </children>
-      <children xsi:type="menu:HandledMenuItem" xmi:id="_TlufMCaGEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.supplemental" label="%command.label.1" command="_bnVKsCZxEeeQLpuomSmVoQ">
-        <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_SwGXYCaJEeeTEd_pKXBflg" coreExpressionId="isCdmStoreConnected"/>
-        <parameters xmi:id="_pebl8CaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.view.supplementalData"/>
-      </children>
-      <children xsi:type="menu:MenuSeparator" xmi:id="_sI4r8CaGEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.menuseparator.0"/>
-      <children xsi:type="menu:HandledMenuItem" xmi:id="_0Dn4cCaHEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.datasource" label="%command.label.2" command="_bnVKsCZxEeeQLpuomSmVoQ">
-        <parameters xmi:id="_54in8CaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.view.datasource"/>
-      </children>
-      <children xsi:type="menu:HandledMenuItem" xmi:id="_1riRcCaHEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.logView" toBeRendered="false" visible="false" label="%command.label.3" command="_bnVKsCZxEeeQLpuomSmVoQ">
-        <parameters xmi:id="_9VpA8CaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="org.eclipse.pde.runtime.LogView"/>
-      </children>
-      <children xsi:type="menu:HandledMenuItem" xmi:id="_3DcfkCaHEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.reporting" label="%command.label.4" command="_bnVKsCZxEeeQLpuomSmVoQ">
-        <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_UrBzACaJEeeTEd_pKXBflg" coreExpressionId="isCdmStoreConnected"/>
-        <parameters xmi:id="_-z-nMCaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.reporting.viewPart"/>
-      </children>
-      <children xsi:type="menu:HandledMenuItem" xmi:id="_jFskQCZyEeeQLpuomSmVoQ" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.sessions" label="%view.name.SESSIONS" command="_bnVKsCZxEeeQLpuomSmVoQ">
-        <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_W-C-gCaJEeeTEd_pKXBflg" coreExpressionId="isCdmStoreConnected"/>
-        <parameters xmi:id="_BylIUCZzEeeQLpuomSmVoQ" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.store.partdescriptor.sessionsView"/>
-      </children>
+  <fragments xsi:type="fragment:StringModelFragment" xmi:id="_3rW8wCXaEeex9MwMOgUeWw" featurename="children" parentElementId="eu.etaxonomy.taxeditor.menu.showView" positionInList="after:bulkeditor.menus.openmenu">
+    <elements xsi:type="menu:HandledMenuItem" xmi:id="_K6sowCaGEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.details" label="%command.label.0" command="_bnVKsCZxEeeQLpuomSmVoQ">
+      <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_Qi6uICaJEeeTEd_pKXBflg" coreExpressionId="isCdmStoreConnected"/>
+      <parameters xmi:id="_h2OecCaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.view.detail"/>
+    </elements>
+    <elements xsi:type="menu:HandledMenuItem" xmi:id="_TlufMCaGEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.supplemental" label="%command.label.1" command="_bnVKsCZxEeeQLpuomSmVoQ">
+      <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_SwGXYCaJEeeTEd_pKXBflg" coreExpressionId="isCdmStoreConnected"/>
+      <parameters xmi:id="_pebl8CaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.view.supplementalData"/>
+    </elements>
+    <elements xsi:type="menu:MenuSeparator" xmi:id="_sI4r8CaGEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.menuseparator.0"/>
+    <elements xsi:type="menu:HandledMenuItem" xmi:id="_0Dn4cCaHEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.datasource" label="%command.label.2" command="_bnVKsCZxEeeQLpuomSmVoQ">
+      <parameters xmi:id="_54in8CaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.view.datasource"/>
+    </elements>
+    <elements xsi:type="menu:HandledMenuItem" xmi:id="_1riRcCaHEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.logView" toBeRendered="false" visible="false" label="%command.label.3" command="_bnVKsCZxEeeQLpuomSmVoQ">
+      <parameters xmi:id="_9VpA8CaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="org.eclipse.pde.runtime.LogView"/>
+    </elements>
+    <elements xsi:type="menu:HandledMenuItem" xmi:id="_3DcfkCaHEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.reporting" label="%command.label.4" command="_bnVKsCZxEeeQLpuomSmVoQ">
+      <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_UrBzACaJEeeTEd_pKXBflg" coreExpressionId="isCdmStoreConnected"/>
+      <parameters xmi:id="_-z-nMCaIEeeTEd_pKXBflg" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.reporting.viewPart"/>
+    </elements>
+    <elements xsi:type="menu:HandledMenuItem" xmi:id="_jFskQCZyEeeQLpuomSmVoQ" elementId="eu.etaxonomy.taxeditor.store.showViewMenu.sessions" label="%view.name.SESSIONS" command="_bnVKsCZxEeeQLpuomSmVoQ">
+      <visibleWhen xsi:type="ui:CoreExpression" xmi:id="_W-C-gCaJEeeTEd_pKXBflg" coreExpressionId="isCdmStoreConnected"/>
+      <parameters xmi:id="_BylIUCZzEeeQLpuomSmVoQ" elementId="eu.etaxonomy.taxeditor.store.showView.parameter.sessionView" name="eu.etaxonomy.taxeditor.workbench.commandparameter.partName" value="eu.etaxonomy.taxeditor.store.partdescriptor.sessionsView"/>
     </elements>
   </fragments>
 </fragment:ModelFragments>
diff --git a/eu.etaxonomy.taxeditor.workbench/fragment.e4xmi b/eu.etaxonomy.taxeditor.workbench/fragment.e4xmi
index 7a71acd59..1514dcd8a 100644
--- a/eu.etaxonomy.taxeditor.workbench/fragment.e4xmi
+++ b/eu.etaxonomy.taxeditor.workbench/fragment.e4xmi
@@ -39,6 +39,7 @@
       </children>
       <children xsi:type="menu:Menu" xmi:id="_FaGntiQNEeen_7LZsZSNoA" elementId="eu.etaxonomy.taxeditor.workbench.menu.edit" toBeRendered="false" visible="false" label="%menu.label.0"/>
       <children xsi:type="menu:Menu" xmi:id="_FaGntyQNEeen_7LZsZSNoA" elementId="eu.etaxonomy.taxeditor.workbench.menu.window" label="%menu.label.1">
+        <children xsi:type="menu:Menu" xmi:id="_DH_m0CkKEeeCvszP-_feIA" elementId="eu.etaxonomy.taxeditor.menu.showView" label="Show View"/>
         <children xsi:type="menu:MenuSeparator" xmi:id="_FaGnuCQNEeen_7LZsZSNoA" elementId="eu.etaxonomy.taxeditor.application.windowMenu.last"/>
         <children xsi:type="menu:HandledMenuItem" xmi:id="_FaGnuSQNEeen_7LZsZSNoA" elementId="org.eclipse.ui.main.menu.window.preferences" label="%command.label.12">
           <command href="../eu.etaxonomy.taxeditor.application/fragment.e4xmi#_l9kXoB7PEeeC-JvycL9ysA"/>