commit 4d01989b1ca8f3f42fc0ae7a113c1f91036ba132
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Fri Aug 17 14:21:30 2018 +0200

    ref #7362 Show info when searching with <4 letters

diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/Messages.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/Messages.java
index 09ff387c8..696d82d27 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/Messages.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/Messages.java
@@ -414,6 +414,8 @@ public class Messages extends NLS {
     public static String GfBioTerminologyImportPresenter_NO_CONNECTION_TITLE;
     public static String GfBioTerminologyImportPresenter_NO_RESULTS_MESSAGE;
     public static String GfBioTerminologyImportPresenter_NO_RESULTS_TITLE;
+    public static String GfBioTerminologyImportPresenter_SEARCH_TOO_SHORT_MESSAGE;
+    public static String GfBioTerminologyImportPresenter_SEARCH_TOO_SHORT_TITLE;
     public static String GfBioTerminologyImportPresenter_TEXT_SEARCH_DEFAULT;
 
     public static String PublishFlagPreference_description;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages.properties b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages.properties
index 72c4f6fb5..42ad74279 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages.properties
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages.properties
@@ -312,6 +312,8 @@ GfBioTerminologyImportPresenter_NO_RESULTS_MESSAGE=No results found for the quer
 GfBioTerminologyImportPresenter_NO_RESULTS_TITLE=No results found
 GfBioTerminologyImportPresenter_COMBO_DEFAULT=All ontologies
 GfBioTerminologyImportPresenter_TEXT_SEARCH_DEFAULT=Enter search term...
+GfBioTerminologyImportPresenter_SEARCH_TOO_SHORT_MESSAGE=Search phrase with <4 letters are not possible for all ontologies. Please select a specific ontology
+GfBioTerminologyImportPresenter_SEARCH_TOO_SHORT_TITLE=Search phrase too short
 
 PublishFlagPreference_description=Configure the default settings for the publish flag in new created taxa
 PublishFlagPreference_do_not_set=Don't set publish flag
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages_de.properties b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages_de.properties
index a1ab59630..a52adb9ef 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages_de.properties
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/l10n/messages_de.properties
@@ -312,6 +312,8 @@ GfBioTerminologyImportPresenter_NO_RESULTS_MESSAGE=Keine Ergebnisse f
 GfBioTerminologyImportPresenter_NO_RESULTS_TITLE=Keine Ergebnisse
 GfBioTerminologyImportPresenter_COMBO_DEFAULT=Alle Ontologien
 GfBioTerminologyImportPresenter_TEXT_SEARCH_DEFAULT=Suchbegriff eingeben...
+GfBioTerminologyImportPresenter_SEARCH_TOO_SHORT_MESSAGE=Suchbegriffe mit <4 Buchstaben sind nicht möglich für alle Ontologien. Bitte eine einzelne Ontologie auswählen.
+GfBioTerminologyImportPresenter_SEARCH_TOO_SHORT_TITLE=Suchbegriff zu kurz
 
 PublishFlagPreference_description=Konfiguration des Default Verhaltens beim Setzen des Publish Flags in einem neu erzeugten Taxon.
 PublishFlagPreference_do_not_set=Publish Flag NICHT setzen
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/GfBioTerminologyImportPresenter.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/GfBioTerminologyImportPresenter.java
index db85cb893..71d814a5d 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/GfBioTerminologyImportPresenter.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/webimport/termimport/GfBioTerminologyImportPresenter.java
@@ -176,9 +176,9 @@ public class GfBioTerminologyImportPresenter {
     }
 
     private void clearDetails(){
-        composite.getLblLabel().setText("");
-        composite.getLblUri().setText("");
-        composite.getLblDescription().setText("");
+        composite.getLblLabel().setText(""); //$NON-NLS-1$
+        composite.getLblUri().setText(""); //$NON-NLS-1$
+        composite.getLblDescription().setText(""); //$NON-NLS-1$
         composite.getListSynonyms().getList().removeAll();
     }
 
@@ -192,9 +192,9 @@ public class GfBioTerminologyImportPresenter {
             String label = wrapper.getLabel();
             String uri = wrapper.getUri();
             String description = wrapper.getDescription();
-            composite.getLblLabel().setText(label!=null?label:"");
-            composite.getLblUri().setText(uri!=null?uri:"");
-            composite.getLblDescription().setText(description!=null?description:"");
+            composite.getLblLabel().setText(label!=null?label:""); //$NON-NLS-1$
+            composite.getLblUri().setText(uri!=null?uri:""); //$NON-NLS-1$
+            composite.getLblDescription().setText(description!=null?description:""); //$NON-NLS-1$
             if(wrapper.getSynonyms()!=null){
                 if(wrapper.getSynonyms().isEmpty()){
                     composite.getListSynonyms().getList().removeAll();
@@ -219,7 +219,11 @@ public class GfBioTerminologyImportPresenter {
         if(searchString.equals(TXT_SEARCH_DEFAULT)){
             return;
         }
-        String terminology = "";
+        if(searchString.length()<4 && composite.getComboTerminologies().getSelection().isEmpty()){
+            MessagingUtils.informationDialog(Messages.GfBioTerminologyImportPresenter_SEARCH_TOO_SHORT_TITLE, Messages.GfBioTerminologyImportPresenter_SEARCH_TOO_SHORT_MESSAGE);
+            return;
+        }
+        String terminology = ""; //$NON-NLS-1$
         ISelection selection = composite.getComboTerminologies().getSelection();
         Collection<OntologyTermWrapper> wrapperList = new ArrayList<>();
         if(selection instanceof IStructuredSelection && !selection.isEmpty()){